/**
 * @file
 * Views Slideshow Xtra Javascript.
 */
(function ($) {
  Drupal.behaviors.viewsSlideshowXtraOverlay = {
    attach: function (context) {
      $('[id^="views-slideshow-xtra-overlay-"]:not(.views-slideshow-xtra-overlay-processed)').addClass('views-slideshow-xtra-overlay-processed').each(function() {
        // Get the slide box.
        var slideArea = $(this).parent().parent().parent().parent().find('.views_slideshow_main');

        // Remove the views slideshow xtra html from the dom
        var xtraHTML = $(this).detach();

        // Attach the views slideshow xtra html to below the main slide.
        $(xtraHTML).appendTo(slideArea);

        // Optionally pause after mouse movement.
//        if (settings.pauseAfterMouseMove) {
//            slideArea.mousemove(function(e) {
//              if (pageX - e.pageX > 5 || pageY - e.pageY > 5) {
//                Drupal.viewsSlideshow.action({ "action": 'pause', "slideshowID": options.slideshowID });
//                clearTimeout(timeout);
//                timeout = setTimeout(function() {
//                    Drupal.viewsSlideshow.action({ "action": 'play', "slideshowID": options.slideshowID });
//                    }, 2000);
//              }
//              pageX = e.pageX;
//              pageY = e.pageY;
//            });
//          }

      });
    }
  };

  Drupal.viewsSlideshowXtraOverlay = Drupal.viewsSlideshowXtraOverlay || {};

  Drupal.viewsSlideshowXtraOverlay.transitionBegin = function (options) {
    
    // Example slideshowID: views_slideshow_xtra_example-page

    // Hide all overlays for all slides.
    $('#views_slideshow_cycle_main_' + options.slideshowID + ' .views-slideshow-xtra-overlay-row').hide();

    // Show the overlays for the current slide.
    $('#views_slideshow_cycle_main_' + options.slideshowID + ' [id^="views-slideshow-xtra-overlay-"]' + ' .views-slideshow-xtra-overlay-row-' + options.slideNum).each(function() {

      var overlay = $(this);
      var overlayContainerId = overlay.parent().attr('id');
      var lastDashPos = overlayContainerId.lastIndexOf('-');
      var currentDisplay = overlayContainerId.substr(lastDashPos + 1);
      var settings = Drupal.settings.viewsSlideshowXtraOverlay[currentDisplay];

      // Fade in or show overlay with optional delay.
      setTimeout(function() {
        if(settings.overlayFadeIn) {
          overlay.fadeIn(settings.overlayFadeIn);    
        } else {
          overlay.show();
        }
      },
        settings.overlayDelay
      );
      
      // Fade out.
      if(settings.overlayFadeOut) {
        setTimeout(function() {
          overlay.fadeOut(settings.overlayFadeOut);
        },
        settings.overlayFadeOutDelay
        );
      }
      
    });
  };
})(jQuery);

